/*
 * ConfigView.cpp
 *
 * Copyright 1997-1998 Geoffrey Clements
 *
 * License:
 * 		This code may be freely used in your programs.
 */

#ifndef CONFIGVIEW_H
#include "ConfigView.h"
#endif

ConfigView::ConfigView (char *view_name, BResources *from_resources) :
	BView (FindWindowResource(view_name, from_resources)) {
	
	rgb_color gray = { 222, 222, 222, 0 };
	SetViewColor(gray);
}

// finds a resource of type B_ARCHIVED_OBJECT
BMessage *ConfigView::FindWindowResource(char *view_name, BResources *from_resources)
{
	void *view_data = NULL;
	BMessage *view_message = NULL;
	
	if (from_resources == NULL){	// from application image
		app_info info;
		if(be_app->GetAppInfo (&info) == B_OK){
			BFile rscfile;
			BResources *rsc = new BResources;
			
			if (rscfile.SetTo (&info.ref, B_READ_ONLY) == B_OK && rsc->SetTo (&rscfile) == B_OK){
				if (rsc->HasResource (B_ARCHIVED_OBJECT, view_name )){
					size_t datasize;
					view_data = rsc->FindResource (B_ARCHIVED_OBJECT, view_name, &datasize);
				}
			}
		}
	}else{
		if (from_resources->HasResource (B_ARCHIVED_OBJECT, view_name )){
			size_t datasize;
			view_data = from_resources->FindResource (B_ARCHIVED_OBJECT, view_name, &datasize);
		}
	}
	
	
	if(view_data != NULL){	// not found
		view_message = new BMessage ();
		view_message->Unflatten((const char *)view_data);
	}

	return view_message;
}
