/*
	
	HandlerWindow.cpp
	
	Copyright 1998 Geoffrey Clements, All Rights Reserved.

*/

#include <Datatypes.h>
#include "HandlerWindow.h"

HandlerWindow::HandlerWindow (BPositionIO &inSource, BRect frame, const char *title, window_type type, uint32 flags, uint32 workspace) :
	BWindow (frame, title, type, flags, workspace) {
	
	DATAInfo in_info;
	DATAIdentify (inSource, NULL, in_info);
	uint32 in_type = in_info.formatType;
	uint32 in_group = in_info.formatGroup;

	DATAInfo *info_list;
	int32 info_count = 0;
	if (DATAGetHandlers (inSource, NULL, info_list, info_count) == B_OK) {
		BView *configView;
		BRect configRect;
		// need a better way of selecting the correct handler
		if ((DATAMakeConfig (info_list[0].formatHandler, NULL,
				configView, configRect) == B_OK) && (configView != NULL)){
			ResizeTo (configRect.right-configRect.left, configRect.bottom-configRect.top);
			MoveTo (100, 100);
			AddChild (configView);
		}
	}
}
