/*
	
	HelloView.cpp
	
	Copyright 1995 Be Incorporated, All Rights Reserved.
	
*/

#ifndef HELLO_VIEW_H
#include "HelloView.h"
#endif

#ifndef EBITMAP_H
#include "EBitmap.h"
#endif
#ifndef EBITMAP_LIB_H
#include "ebitmap_lib.h"
#endif
#ifndef D_THUMBNAIL_H
#include "Thumbnail.h"
#endif

HelloView::HelloView(BRect rect, char *name, BBitmap *bitMap)
	   	   : BView(rect, name, B_FOLLOW_ALL, B_WILL_DRAW)
{
	bm = bitMap;
}


void HelloView::AttachedToWindow()
{
}


void HelloView::Draw(BRect)
{
	DrawBitmap(bm);
}

void HelloView::MouseDown (BPoint where) {
	BMessage *dragMessage;
	DThumbnail thumbnail(bm, true);
	BPoint pt(1, 1);
	// make a copy of Thumbnail's Bitmap
	BBitmap *iconBm = new BBitmap (thumbnail.Bitmap ()->Bounds (), thumbnail.Bitmap ()->ColorSpace ());
	// Yikes! we should have some error checking here!
	memcpy (iconBm->Bits (), thumbnail.Bitmap ()->Bits (), thumbnail.Bitmap ()->BitsLength ());
	
	dragMessage = bbitmap_to_ebitmap (bm);
	
	if (dragMessage != NULL) {
		DragMessage (dragMessage, iconBm, pt);
		delete dragMessage;
	}
}
